#pragma once
#include <gfx.hpp>

//extern const uint8_t snake_head_8x8_mask[];
//extern const uint16_t snake_head_8x8_right_data[];
//extern const uint8_t *snake_body_8x8_mask;
//extern const uint16_t snake_body_8x8_data[];
//extern const uint8_t snake_tongue_8x8_mask[];
//extern const uint16_t snake_tongue_8x8_data[];


//#ifdef SNAKE_8x8_IMPLEMENTATION

const uint8_t snake_head_8x8_mask[] = {
	0x18, 0x3C, 0x7E, 0xFF, 0xFF, 0x7E, 0x3C, 0x18
};

const uint16_t snake_head_8x8_right_data[] {
	0x0000, 0x0000, 0x0000, 0x454B, 0x454B, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x454B, 0xAD34, 0xAD34, 0x454B, 0x0000, 0x0000,   // 0x0010 (16) pixels
	0x0000, 0x454B, 0xAD34, 0xE66D, 0xE66D, 0x3E01, 0x454B, 0x0000, 
	0x454B, 0xAD34, 0xE66D, 0x2A9F, 0x2A9F, 0xE66D, 0xAD34, 0x454B,   // 0x0020 (32) pixels
	0x454B, 0xAD34, 0xE66D, 0x2A9F, 0x2A9F, 0xE66D, 0xAD34, 0x454B, 
	0x0000, 0x454B, 0xAD34, 0xE66D, 0xE66D, 0x3E01, 0x454B, 0x0000,   // 0x0030 (48) pixels
	0x0000, 0x0000, 0x454B, 0xAD34, 0xAD34, 0x454B, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x454B, 0x454B, 0x0000, 0x0000, 0x0000,   // 0x0040 (64) pixels
};

const uint16_t snake_head_8x8_left_data[] {
	0x0000, 0x0000, 0x0000, 0x454B, 0x454B, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x454B, 0xAD34, 0xAD34, 0x454B, 0x0000, 0x0000,   // 0x0010 (16) pixels
	0x0000, 0x454B, 0x3E01, 0xE66D, 0xE66D, 0xAD34, 0x454B, 0x0000, 
	0x454B, 0xAD34, 0xE66D, 0x2A9F, 0x2A9F, 0xE66D, 0xAD34, 0x454B,   // 0x0020 (32) pixels
	0x454B, 0xAD34, 0xE66D, 0x2A9F, 0x2A9F, 0xE66D, 0xAD34, 0x454B, 
	0x0000, 0x454B, 0x3E01, 0xE66D, 0xE66D, 0xAD34, 0x454B, 0x0000,   // 0x0030 (48) pixels
	0x0000, 0x0000, 0x454B, 0xAD34, 0xAD34, 0x454B, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x454B, 0x454B, 0x0000, 0x0000, 0x0000,   // 0x0040 (64) pixels
};

const uint16_t snake_head_8x8_up_data[] {
	0x0000, 0x0000, 0x0000, 0x454B, 0x454B, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x454B, 0xAD34, 0xAD34, 0x454B, 0x0000, 0x0000,   // 0x0010 (16) pixels
	0x0000, 0x454B, 0x3E01, 0xE66D, 0xE66D, 0x3E01, 0x454B, 0x0000, 
	0x454B, 0xAD34, 0xE66D, 0x2A9F, 0x2A9F, 0xE66D, 0xAD34, 0x454B,   // 0x0020 (32) pixels
	0x454B, 0xAD34, 0xE66D, 0x2A9F, 0x2A9F, 0xE66D, 0xAD34, 0x454B, 
	0x0000, 0x454B, 0xAD34, 0xE66D, 0xE66D, 0xAD34, 0x454B, 0x0000,   // 0x0030 (48) pixels
	0x0000, 0x0000, 0x454B, 0xAD34, 0xAD34, 0x454B, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x454B, 0x454B, 0x0000, 0x0000, 0x0000,   // 0x0040 (64) pixels
};

const uint16_t snake_head_8x8_down_data[] {
	0x0000, 0x0000, 0x0000, 0x454B, 0x454B, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x454B, 0xAD34, 0xAD34, 0x454B, 0x0000, 0x0000,   // 0x0010 (16) pixels
	0x0000, 0x454B, 0xAD34, 0xE66D, 0xE66D, 0xAD34, 0x454B, 0x0000, 
	0x454B, 0xAD34, 0xE66D, 0x2A9F, 0x2A9F, 0xE66D, 0xAD34, 0x454B,   // 0x0020 (32) pixels
	0x454B, 0xAD34, 0xE66D, 0x2A9F, 0x2A9F, 0xE66D, 0xAD34, 0x454B, 
	0x0000, 0x454B, 0x3E01, 0xE66D, 0xE66D, 0x3E01, 0x454B, 0x0000,   // 0x0030 (48) pixels
	0x0000, 0x0000, 0x454B, 0xAD34, 0xAD34, 0x454B, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x454B, 0x454B, 0x0000, 0x0000, 0x0000,   // 0x0040 (64) pixels
};


//const uint8_t *snake_body_8x8_mask = snake_head_8x8_mask;

const uint16_t snake_body_8x8_data[] {
	0x0000, 0x0000, 0x0000, 0x454B, 0x454B, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x454B, 0xAD34, 0xAD34, 0x454B, 0x0000, 0x0000,   // 0x0010 (16) pixels
	0x0000, 0x454B, 0xAD34, 0xE66D, 0xE66D, 0xAD34, 0x454B, 0x0000, 
	0x454B, 0xAD34, 0xE66D, 0x2A9F, 0x2A9F, 0xE66D, 0xAD34, 0x454B,   // 0x0020 (32) pixels
	0x454B, 0xAD34, 0xE66D, 0x2A9F, 0x2A9F, 0xE66D, 0xAD34, 0x454B, 
	0x0000, 0x454B, 0xAD34, 0xE66D, 0xE66D, 0xAD34, 0x454B, 0x0000,   // 0x0030 (48) pixels
	0x0000, 0x0000, 0x454B, 0xAD34, 0xAD34, 0x454B, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x454B, 0x454B, 0x0000, 0x0000, 0x0000,   // 0x0040 (64) pixels
};

////////////////////////////////////////////////////////////////////////////////
// The tongue
//
// +--------+
// |        |
// |    *   |
// |  **    |
// |**      |
// |**      |
// |  **    |
// |    *   |
// |        |
// +--------+
//
// * = red (0xF800 in rgb565 color space)
////////////////////////////////////////////////////////////////////////////////
const uint8_t snake_tongue_8x8_mask[] = {
	0x00, 0x08, 0x30, 0xC0, 0xC0, 0x30, 0x08, 0x00
};

const uint16_t snake_tongue_8x8_data[] = {
    0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,  // Line 1
    0x0000, 0x0000, 0x0000, 0x0000, 0x00F8, 0x0000, 0x0000, 0x0000,  // Line 2
    0x0000, 0x0000, 0x00F8, 0x00F8, 0x0000, 0x0000, 0x0000, 0x0000,  // Line 3
    0x00F8, 0x00F8, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,  // Line 4
    0x00F8, 0x00F8, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,  // Line 5
    0x0000, 0x0000, 0x00F8, 0x00F8, 0x0000, 0x0000, 0x0000, 0x0000,  // Line 6
    0x0000, 0x0000, 0x0000, 0x0000, 0x00F8, 0x0000, 0x0000, 0x0000,  // Line 7
    0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,  // Line 8
};


//#endif //SNAKE_HEAD_IMPLEMENTATION